#include "Utilities.jsx"
#include "json2.js"

function applyFont(fontObject)
{
    try
    {           
        if (app.documents.length > 0 && app.activeDocument && app.activeDocument.layers && app.activeDocument.layers.length > 0)
        {
            var ref= new ActionReference();
            var setDesc = new ActionDescriptor();
            var fontDesc = new ActionDescriptor();
            
            var postScriptName = fontObject.fontName;
            
            for (var i = 0; i < app.fonts.length; ++i)
            {
                var textFont = app.fonts[i];
                if (textFont != null)
                {
                    if (postScriptNamesMatch(textFont.postScriptName, fontObject.fontName))
                    {
                        postScriptName = textFont.postScriptName;
                        break;
                    }
                }
            }
            
            ref.putProperty(app.charIDToTypeID('Prpr'), app.charIDToTypeID('TxtS'));
            ref.putEnumerated(app.charIDToTypeID('TxLr'), app.charIDToTypeID('Ordn'), app.charIDToTypeID('Trgt'));
            
            setDesc.putReference(app.charIDToTypeID('null'), ref);
            
            fontDesc.putString(app.stringIDToTypeID("fontPostScriptName"), postScriptName);
            fontDesc.putString(app.charIDToTypeID('FntN'), postScriptName);
            
            setDesc.putObject(app.charIDToTypeID('T   '), app.charIDToTypeID('TxtS'), fontDesc);
            
            app.executeAction(app.charIDToTypeID('setd'), setDesc, DialogModes.NO);
        }
    }
    catch (e)
    {
        trace(e);
        
        return false;
        // Prevent Photoshop from crashing
    }

    return true;
}

 function isFontActivated(font)
{
    app.refreshFonts();
    for (var i = 0; i < app.fonts.length; ++i)
    {
        var textFont = app.fonts[i];
        if (textFont != null)
        {
            if (postScriptNamesMatch(textFont.postScriptName, font.name))
            {
                var returnObject = {isActivated: true, fontID: font.id};
                return JSON.stringify(returnObject);
            }
        }
    }
    
    var returnObject = {isActivated: false, fontID: font.id};
    return JSON.stringify(returnObject);
}

function updateSelection()
{
    var fontName = "";

    if(app.documents.length > 0)
    {
        var currentLayer = app.activeDocument.activeLayer ;

        if(currentLayer
            && currentLayer.kind == LayerKind.TEXT
            && currentLayer.textItem.contents != "")
        {
            fontName = currentLayer.textItem.font;
        }
    }

    return fontName;
}

function isGUIBlockingPanel()
{
    var blocking = true;
    
    try
    {
        app.backgroundColor;
        blocking = false;
    }
    catch(e)
    {
        // This space intentionally left empty
    }

    return blocking;
}
